;gsc4.orc
;
;
;                           SINTESI GRANULARE
;                          -------------------
;                               Ver 2.1
;                            Eugenio Giordani
;                            
;
;----------------------------------------------------------------------------
;Questa orchestra implementa la Sintesi Granulare secondo il modello
;proposto da B. Truax. 
;
;--------------   ORCHESTRA HEADER   ----------
;NOTE: per una miglioe qualit audio ksmps = 1
;
sr = 44100
kr = 22050
ksmps = 2
nchnls = 2
;---------- Inizializzazione delle variabili globali di controllo ---------
;
gkdur    init 0  ;durata media dei grani 
gkdurr   init 0  ;variazione random della durata dei grani
gkdel    init 0  ;delay medio dei grani
gkdelr   init 0  ;variazione random del delay dei grani
gkramp   init 0  ;rapporto di rampa
gkfreq   init 0  ;frequenza media del segnale audio 
gkfreqr  init 0  ;variazione random della frequenza del segnale audio
gkphase  init 0  ;fase del segnale audio 
gkphaser init 0  ;variazione random della fase del segnale audio 
gkamp    init 0  ;ampiezza globale

gkran  init 0    ;frequenza random istantanea 

gkrnd1 init 0    ;durata random istantanea dei grani (VOCE #1)
gkrnd2 init 0    ;                                   (VOCE #2)
gkrnd3 init 0    ;                                   (VOCE #3)
gkrnd4 init 0    ;                                   (VOCE #4)

gkrnd1y init 0   ;delay random istantaneo dei grani  (VOCE #1)                        
gkrnd2y init 0   ;                                   (VOCE #2)                      
gkrnd3y init 0   ;                                   (VOCE #3)
gkrnd4y init 0   ;                                   (VOCE #4)

gkrnd1p init 0   ;fase random istantanea             (VOCE #1)
gkrnd2p init 0   ;                                   (VOCE #2)                      
gkrnd3p init 0   ;                                   (VOCE #3)
gkrnd4p init 0   ;                                   (VOCE #4)

;---------------------------------------------------------------------------
instr 1
;====================== GENERATORE DEI GRANI (VOCE #1)==========================
ifun   =  p4      ;funzione audio
;
	
;
;       Aggiornamento dei parametri dei grani (ri-inizializzazione) 
;       ----------------------------------------------------------
loop:
idur = i(gkdur)        ;il valore corrente di gkdur  campionato 
                       ;dal generatore corrispondente nell instr 11
                       ;e convertito in variabile di tipo i

idurr = i(gkrnd1)      ;il valore corrente di gkrnd1  ......

itrpz = abs(0.001* (idur + idurr))  ;calcola la durata del trapezoide

iramp = i(gkramp)+ 0.1  ;il valore corrente di gkramp (pi un numero magico) .. 

idel  = i(gkdel)        ;il valore corrente di gkdel....       
idelr = i(gkrnd1y)      ;il valore corrente di gkrnd1y....
idely = abs(0.001 * (idel + idelr)) ;calcola il delay complessivo

ifreq   = i(gkfreq)      ;il valore corrente di gkfreq  ....
ifreqr  = i(gkran)       ;il valore corrente di gkran  ....
iphase  = i(gkphase)     ;il valore corrente di gkphase  ....
iphaser = i(gkrnd1p)     ;il valore corrente di gkrn1p  ....
iamp    = i(gkamp)       ;il valore corrente di gkamp  ....      

irise   = itrpz/iramp            ;calcola il tempo di salita del trapezoide 
isus    = itrpz - (2 * irise)    ;calcola la durata di sustain del trapezoide
igrain  = itrpz + idely          ;calcola la durata trapezoide+delay
iph     = abs(iphase + iphaser)  ;calcola la fase complessiva
ifq     = ifreq + ifreqr         ;calcola la frequenza complessiva
		


;---------- Sezione di simulazione dell interrupt (interruzione) ----------
;
;Lopcode timout lavora come un generatore di interrupt. Timout  caricato
;con la durata corrente del grano and decrementato in modo automatico fino a ;zero


timout 0,igrain,cont   ;se il valore del contatore  diverso da zero vai a cont
						   
reinit loop            ;altrimenti salta alla reinizializzazione

cont:
k1 linseg 0,irise,iamp,isus,iamp,irise,0,idel,0 ;genera linviluppo dei grani
                                                ;
ga1 oscili k1,ifq,ifun,iph  ;genera voce 1

 
endin

;---------------------------------------------------------------------------
instr 2
;====================== GENERATORE DEI GRANI (VOCE #2)==========================
ifun   =  p4      ;funzione audio
;
	
;
;       Aggiornamento dei parametri dei grani (ri-inizializzazione) 
;       ----------------------------------------------------------
loop:
idur = i(gkdur)        ;il valore corrente di gkdur  campionato 
                       ;dal generatore corrispondente nell instr 11
                       ;e convertito in variabile di tipo i

idurr = i(gkrnd2)      ;il valore corrente di gkrnd2  ......

itrpz = abs(0.001* (idur + idurr))  ;calcola la durata del trapezoide

iramp = i(gkramp)+ 0.1  ;il valore corrente di gkramp (pi un numero magico) .. 

idel  = i(gkdel)        ;il valore corrente di gkdel....       
idelr = i(gkrnd2y)      ;il valore corrente di gkrnd2y....
idely = abs(0.001 * (idel + idelr)) ;calcola il delay complessivo

ifreq   = i(gkfreq)      ;il valore corrente di gkfreq  ....
ifreqr  = i(gkran)       ;il valore corrente di gkran  ....
iphase  = i(gkphase)     ;il valore corrente di gkphase  ....
iphaser = i(gkrnd2p)     ;il valore corrente di gkrn2p  ....
iamp    = i(gkamp)       ;il valore corrente di gkamp  ....      

irise   = itrpz/iramp            ;calcola il tempo di salita del trapezoide 
isus    = itrpz - (2 * irise)    ;calcola la durata di sustain del trapezoide
igrain  = itrpz + idely          ;calcola la durata trapezoide+delay
iph     = abs(iphase + iphaser)  ;calcola la fase complessiva
ifq     = ifreq + ifreqr         ;calcola la frequenza complessiva
		


;---------- Sezione di simulazione dell interrupt (interruzione) ----------
;
;Lopcode timout lavora come un generatore di interrupt. Timout  caricato
;con la durata corrente del grano and decrementato in modo automatico fino a ;zero


timout 0,igrain,cont   ;se il valore del contatore  diverso da zero vai a cont
						   
reinit loop            ;altrimenti salta alla reinizializzazione

cont:
k1 linseg 0,irise,iamp,isus,iamp,irise,0,idel,0 ;genera linviluppo dei grani
                                                ;
ga2 oscili k1,ifq,ifun,iph  ;genera voce 2

 
endin
;---------------------------------------------------------------------------
instr 3
;====================== GENERATORE DEI GRANI (VOCE #3)==========================
ifun   =  p4      ;funzione audio
;
	
;
;       Aggiornamento dei parametri dei grani (ri-inizializzazione) 
;       ----------------------------------------------------------
loop:
idur = i(gkdur)        ;il valore corrente di gkdur  campionato 
                       ;dal generatore corrispondente nell instr 11
                       ;e convertito in variabile di tipo i

idurr = i(gkrnd3)      ;il valore corrente di gkrnd3  ......

itrpz = abs(0.001* (idur + idurr))  ;calcola la durata del trapezoide

iramp = i(gkramp)+ 0.1  ;il valore corrente di gkramp (pi un numero magico) .. 

idel  = i(gkdel)        ;il valore corrente di gkdel....       
idelr = i(gkrnd3y)      ;il valore corrente di gkrnd3y....
idely = abs(0.001 * (idel + idelr)) ;calcola il delay complessivo

ifreq   = i(gkfreq)      ;il valore corrente di gkfreq  ....
ifreqr  = i(gkran)       ;il valore corrente di gkran  ....
iphase  = i(gkphase)     ;il valore corrente di gkphase  ....
iphaser = i(gkrnd3p)     ;il valore corrente di gkrnd3p  ....
iamp    = i(gkamp)       ;il valore corrente di gkamp  ....      

irise   = itrpz/iramp            ;calcola il tempo di salita del trapezoide 
isus    = itrpz - (2 * irise)    ;calcola la durata di sustain del trapezoide
igrain  = itrpz + idely          ;calcola la durata trapezoide+delay
iph     = abs(iphase + iphaser)  ;calcola la fase complessiva
ifq     = ifreq + ifreqr         ;calcola la frequenza complessiva
		


;---------- Sezione di simulazione dell interrupt (interruzione) ----------
;
;Lopcode timout lavora come un generatore di interrupt. Timout  caricato
;con la durata corrente del grano and decrementato in modo automatico fino a ;zero


timout 0,igrain,cont   ;se il valore del contatore  diverso da zero vai a cont
						   
reinit loop            ;altrimenti salta alla reinizializzazione

cont:
k1 linseg 0,irise,iamp,isus,iamp,irise,0,idel,0 ;genera linviluppo dei grani
                                                ;
ga3 oscili k1,ifq,ifun,iph  ;genera voce 3

 
endin
;---------------------------------------------------------------------------
instr 4
;====================== GENERATORE DEI GRANI (VOCE #4)==========================
ifun   =  p4      ;funzione audio
;
	
;
;       Aggiornamento dei parametri dei grani (ri-inizializzazione) 
;       ----------------------------------------------------------
loop:
idur = i(gkdur)        ;il valore corrente di gkdur  campionato 
                       ;dal generatore corrispondente nell instr 11
                       ;e convertito in variabile di tipo i

idurr = i(gkrnd4)      ;il valore corrente di gkrnd4  ......

itrpz = abs(0.001* (idur + idurr))  ;calcola la durata del trapezoide

iramp = i(gkramp)+ 0.1  ;il valore corrente di gkramp (pi un numero magico) .. 

idel  = i(gkdel)        ;il valore corrente di gkdel....       
idelr = i(gkrnd4y)      ;il valore corrente di gkrnd4y....
idely = abs(0.001 * (idel + idelr)) ;calcola il delay complessivo

ifreq   = i(gkfreq)      ;il valore corrente di gkfreq  ....
ifreqr  = i(gkran)       ;il valore corrente di gkran  ....
iphase  = i(gkphase)     ;il valore corrente di gkphase  ....
iphaser = i(gkrnd4p)     ;il valore corrente di gkrnd4p  ....
iamp    = i(gkamp)       ;il valore corrente di gkamp  ....      

irise   = itrpz/iramp            ;calcola il tempo di salita del trapezoide 
isus    = itrpz - (2 * irise)    ;calcola la durata di sustain del trapezoide
igrain  = itrpz + idely          ;calcola la durata trapezoide+delay
iph     = abs(iphase + iphaser)  ;calcola la fase complessiva
ifq     = ifreq + ifreqr         ;calcola la frequenza complessiva
		

;---------- Sezione di simulazione dell interrupt (interruzione) ----------
;
;Lopcode timout lavora come un generatore di interrupt. Timout  caricato
;con la durata corrente del grano and decrementato in modo automatico fino a ;zero


timout 0,igrain,cont   ;se il valore del contatore  diverso da zero vai a cont
						   
reinit loop            ;altrimenti salta alla reinizializzazione

cont:
k1 linseg 0,irise,iamp,isus,iamp,irise,0,idel,0 ;genera linviluppo dei grani
                                                ;
ga4 oscili k1,ifq,ifun,iph  ;genera la voce 4

 
endin

;=============================== CONTROLLO DEI GRANI =========================
instr 11
;NOTE: tutte le variabili globali sono trasmesse agli instr 1,2,3,4
;
gkdur    oscil1  0,1,p3,p4       ;generatore di controllo per    idur
gkdurr   oscil1  0,1,p3,p5       ;                               idurr    
gkdel    oscil1  0,1,p3,p6       ;                               idel
gkdelr   oscil1  0,1,p3,p7       ;                               idelr
gkramp   oscil1  0,1,p3,p8       ;                               iramp
gkfreq   oscil1  0,1,p3,p9       ;                               ifreq
gkfreqr  oscil1  0,1,p3,p10      ;                               ifreqr
gkphase  oscil1  0,1,p3,p11      ;                               iphase
gkphaser oscil1  0,1,p3,p12      ;                               iphaser
gkamp    oscil1  0,1,p3,p13      ;                               iamp
;
krnd1  rand 1 ,0.1         ;generatore random (VOCE #1)
krnd2  rand 1 ,0.9         ;                  (VOCE #2)
krnd3  rand 1 ,0.5         ;                  (VOCE #3)
krnd4  rand 1 ,0.3         ;                  (VOCE #4)

;I valori istantanei dei generatori random sono riscalati per ottenere i valori ;opportuni di frequenza, durata, delay e fase

gkran  = krnd1 * gkfreqr/2 ;riscalatura per la frequenza random (VOCE #1,2,3,4)

gkrnd1 = krnd1 * gkdurr/2  ;riscalatura per la variaz.random di durata(VOCE #1)
gkrnd2 = krnd2 * gkdurr/2  ;                                          (VOCE #2)
gkrnd3 = krnd3 * gkdurr/2  ;                                          (VOCE #3)
gkrnd4 = krnd4 * gkdurr/2  ;                                          (VOCE #4)

gkrnd1y = krnd1 * (0.05 + gkdelr /2) ;riscalatura variaz. random delay(VOCE #1)
gkrnd2y = krnd2 * (0.05 + gkdelr /2) ;                                (VOCE #2)
gkrnd3y = krnd3 * (0.05 + gkdelr /2) ;                                (VOCE #3)
gkrnd4y = krnd4 * (0.05 + gkdelr /2) ;                                (VOCE #4)

gkrnd1p = krnd1 * gkphaser/2   ;riscalatura variaz. random fase(VOCE #1)
gkrnd2p = krnd2 * gkphaser/2   ;                               (VOCE #2)
gkrnd3p = krnd3 * gkphaser/2   ;                               (VOCE #3)
gkrnd4p = krnd4 * gkphaser/2   ;                               (VOCE #4)

endin

;======================== RISCALATURA, MIX & OUT =======================

instr 21
iscale = p4               	;legge dalla score il fattore di scala
outs1 (ga1/2 + ga2/2) * iscale  	;manda in uscita left le voci 1 e 2
outs2 (ga3/2 + ga4/2) * iscale  	;manda in uscita right le voci 3 e 4
				    				
endin

 
